// CLRHosting.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "clrloader.h"
#include "Windows.h"
#include <stdlib.h>
#include "strings.h"

#pragma comment(linker, "/EXPORT:Execute=_Execute@4")
#pragma comment(linker, "/EXPORT:ExtractRuntime=_ExtractRuntime@4")
#pragma comment(linker, "/EXPORT:ManagedInstall=_ManagedInstall@4")
#pragma comment(linker, "/EXPORT:ManagedUninstall=_ManagedUninstall@4")
#pragma comment(linker, "/EXPORT:ManagedRollback=_ManagedRollback@4")
#pragma comment(linker, "/EXPORT:ManagedCommit=_ManagedCommit@4")



extern "C" UINT __stdcall ManagedInstall (MSIHANDLE hInstall) {
	  
	
	HRESULT hr = S_OK;
	OutputDebugStringA(LPCTSTR( "Running Install method..."));

	// Create an instance of a managed addin
	// and fetch the interface pointer
    CCLRLoader *pCLRLoader = CCLRLoader::TheInstance();
	OutputDebugStringA(LPCTSTR( "Setting installer handle"));
	pCLRLoader->m_MsiHandle = hInstall;
    IfNullGo(pCLRLoader);
	OutputDebugStringA(LPCTSTR( "Running installer action"));
	IfFailGo(pCLRLoader->RunMethod(szManagedInstallMethod));
	
	return ERROR_SUCCESS;

	Error:
		char  buffer[200];
	
		sprintf_s(buffer, 200, "Error: %d\n", hr);

	OutputDebugStringA(LPCTSTR( buffer ));
		return hr;	
	
  
}

extern "C" UINT __stdcall ManagedUninstall (MSIHANDLE hInstall) {
	  
	
	HRESULT hr = S_OK;
	OutputDebugStringA(LPCTSTR( "Running Uninstall method..."));

	// Create an instance of a managed addin
	// and fetch the interface pointer
    CCLRLoader *pCLRLoader = CCLRLoader::TheInstance();
	OutputDebugStringA(LPCTSTR( "Setting installer handle"));
	pCLRLoader->m_MsiHandle = hInstall;
    IfNullGo(pCLRLoader);
	OutputDebugStringA(LPCTSTR( "Running installer action"));
	IfFailGo(pCLRLoader->RunMethod(szManagedUninstallMethod));
	
	return ERROR_SUCCESS;

	Error:
		char  buffer[200];
	
		sprintf_s(buffer, 200, "Error: %d\n", hr);

	OutputDebugStringA(LPCTSTR( buffer ));
		return hr;	
	
  
}
extern "C" UINT __stdcall ManagedCommit (MSIHANDLE hInstall) {
	  
	
	HRESULT hr = S_OK;
	OutputDebugStringA(LPCTSTR( "Running Commit method..."));

	// Create an instance of a managed addin
	// and fetch the interface pointer
    CCLRLoader *pCLRLoader = CCLRLoader::TheInstance();
	OutputDebugStringA(LPCTSTR( "Setting installer handle"));
	pCLRLoader->m_MsiHandle = hInstall;
    IfNullGo(pCLRLoader);
	OutputDebugStringA(LPCTSTR( "Running installer action"));
	IfFailGo(pCLRLoader->RunMethod(szManagedCommitMethod));
	
	return ERROR_SUCCESS;

	Error:
		char  buffer[200];
	
		sprintf_s(buffer, 200, "Error: %d\n", hr);

	OutputDebugStringA(LPCTSTR( buffer ));
		return hr;	
	
  
}
extern "C" UINT __stdcall ManagedRollback (MSIHANDLE hInstall) {
	  
		OutputDebugStringA(LPCTSTR( "Running Rollback method..."));

	HRESULT hr = S_OK;

	// Create an instance of a managed addin
	// and fetch the interface pointer
    CCLRLoader *pCLRLoader = CCLRLoader::TheInstance();
	OutputDebugStringA(LPCTSTR( "Setting installer handle"));
	pCLRLoader->m_MsiHandle = hInstall;
    IfNullGo(pCLRLoader);
	OutputDebugStringA(LPCTSTR( "Running installer action"));
	IfFailGo(pCLRLoader->RunMethod(szManagedRollbackMethod));
	
	return ERROR_SUCCESS;

	Error:
		char  buffer[200];
	
		sprintf_s(buffer, 200, "Error: %d\n", hr);

	OutputDebugStringA(LPCTSTR( buffer ));
		return hr;	
	
  
}


extern "C" UINT __stdcall Execute (MSIHANDLE hInstall) {
	  
	HRESULT hr = S_OK;

	// Create an instance of a managed addin
	// and fetch the interface pointer
	OutputDebugStringA(LPCTSTR( "Running Execute method..."));
    CCLRLoader *pCLRLoader = CCLRLoader::TheInstance();
	OutputDebugStringA(LPCTSTR( "Setting installer handle"));
	pCLRLoader->m_MsiHandle = hInstall;
    IfNullGo(pCLRLoader);
	OutputDebugStringA(LPCTSTR( "Running custom action"));
    IfFailGo(pCLRLoader->RunCustomActions());
	
	return ERROR_SUCCESS;

	Error:
		char  buffer[200];
	
		sprintf_s(buffer, 200, "Error: %d\n", hr);

	OutputDebugStringA(LPCTSTR( buffer ));
		return hr;	
	
  
}

extern "C" UINT __stdcall ExtractRuntime (MSIHANDLE hInstall) {
	HRESULT hr = S_OK;

	// Create an instance of a managed addin
	// and fetch the interface pointer
	OutputDebugStringA(LPCTSTR( "Initializing runtime..."));
    CCLRLoader *pCLRLoader = CCLRLoader::TheInstance();
	OutputDebugStringA(LPCTSTR( "Setting installer handle"));
	pCLRLoader->m_MsiHandle = hInstall;
    IfNullGo(pCLRLoader);
	OutputDebugStringA(LPCTSTR( "Extracting custom action runtime to temp directory"));
    IfFailGo(pCLRLoader->ExtractRuntime());
	OutputDebugStringA(LPCTSTR( "Managed custom action runtime was extracted successfully"));
	return ERROR_SUCCESS;

	Error:
		char  buffer[200];
	
		sprintf_s(buffer, 200, "Error: %d\n", hr);

	OutputDebugStringA(LPCTSTR( buffer ));
		return hr;	
	
}
