using System;

namespace InfiniTec.Configuration.Install
{
	/// <summary>
	/// InstallState enum of the microsoft installer.
	/// </summary>
	public enum InstallState
	{
		NotUsed = -7,  // component disabled
		BadConfig = -6,  // configuration data corrupt
		Incomplete = -5,  // installation suspended or in progress
		SourceAbsent = -4,  // run from source, source is unavailableusing System;
		MoreData = -3,  // return buffer overflow
		InvalidArgs = -2,  // invalid function argument
		Unknown = -1,  // unrecognized product or feature
		Broken = 0,  // broken
		Advertised = 1,  // advertised feature
		Removed = 1,  // component being removed (action state, not settable)
		Absent = 2,  // uninstalled (or action state absent but clients remain)
		Local = 3,  // installed on local drive
		Source = 4,  // run from source, CD or net
		Default = 5,  // use default, local or source
	}
}
