namespace InfiniTec.Configuration.Install
{
    public enum InstallerRunMode
    {
        /// <summary>
        /// admin mode install, else product install
        /// </summary>
        Admin = 0,
        /// <summary>
        /// installing advertisements, else installing or updating product
        /// </summary>
        Advertise = 1,
        /// <summary>
        /// modifying an existing installation, else new installation
        /// </summary>
        Maintenance = 2,
        /// <summary>
        /// rollback is enabled
        /// </summary>
        RollbackEnabled = 3,
        /// <summary>
        /// log file active, enabled prior to install session
        /// </summary>
        LogEnabled = 4,
        /// <summary>
        /// spooling execute operations, else in determination phase
        /// </summary>
        Operations = 5,
        /// <summary>
        /// reboot needed after successful installation (settable)
        /// </summary>
        RebootAtEnd = 6,
        /// <summary>
        /// reboot needed to continue installation (settable)
        /// </summary>
        RebootNow = 7,
        /// <summary>
        /// installing files from cabinets and files using Media table
        /// </summary>
        Cabinet = 8,
        /// <summary>
        /// source LongFileNames suppressed via PID_MSISOURCE summary property
        /// </summary>
        SourceShortNames = 9,
        /// <summary>
        /// target LongFileNames suppressed via SHORTFILENAMES property
        /// </summary>
        TargetShortNames = 10,
        /// <summary>
        /// future use
        /// </summary>
        Reserved11 = 11,
        /// <summary>
        /// operating systems is Windows9?, else Windows NT
        /// </summary>
        Windows9X = 12,
        /// <summary>
        /// operating system supports demand installation
        /// </summary>
        ZAWEnabled = 13,
        /// <summary>
        /// future use
        /// </summary>
        Reserved14 = 14,
        /// <summary>
        /// future use
        /// </summary>
        Reserved15 = 15,
        /// <summary>
        /// custom action call from install script execution
        /// </summary>
        Scheduled = 16,
        /// <summary>
        /// custom action call from rollback execution script
        /// </summary>
        Rollback = 17,
        /// <summary>
        /// custom action call from commit execution script
        /// </summary>
        Commit = 18,
    }
}
