﻿using System;
using Microsoft.Win32.SafeHandles;

namespace InfiniTec.Configuration.Install
{
    public class MsiHandle: SafeHandleMinusOneIsInvalid
    {
        private static readonly MsiHandle _Zero = new MsiHandle(IntPtr.Zero);

        public MsiHandle() : base(true)
        {
        }


        public MsiHandle(IntPtr handle) : base(false)
        {
            this.handle = handle;
        }

        public static MsiHandle Zero
        {
            get { return _Zero; }
        }

        protected override bool ReleaseHandle()
        {
            return (NativeMethods.MsiCloseHandle(handle) == 0);
        }
    }
}
