using System;
using System.Runtime.InteropServices;
using System.Text;

namespace InfiniTec.Configuration.Install
{
	/// <summary>
	/// Static class for native dll-imported methods.
	/// </summary>
	internal static class NativeMethods
	{
		[DllImport("msi.dll", CharSet = CharSet.Unicode)]
		internal static extern int MsiGetProperty(MsiHandle hInstall, string szName, [Out] StringBuilder szValueBuf, ref int pchValueBuf);

		[DllImport("msi.dll", CharSet = CharSet.Unicode)]
		internal static extern int MsiSetProperty(MsiHandle hInstall, string szName, string szValue);

        [DllImport("msi.dll", CharSet = CharSet.Unicode)]
        extern static public int MsiProcessMessage(MsiHandle install,
            uint messageType, MsiHandle record);
		[DllImport("msi.dll", CharSet = CharSet.Unicode)]
		internal static extern int MsiSetTargetPath(MsiHandle hInstall, string szFolder, string szFolderPath);

		[DllImport("msi.dll", CharSet = CharSet.Unicode)]
		internal static extern int MsiDoAction(MsiHandle hInstall, string szAction);

		[DllImport("msi.dll", CharSet = CharSet.Unicode)]
		internal static extern MsiCondition MsiEvaluateCondition(MsiHandle hInstall, string szCondition);

		[DllImport("msi.dll", ExactSpelling = true)]
		internal static extern short MsiGetLanguage(MsiHandle hInstall);

		[DllImport("msi.dll", CharSet = CharSet.Unicode)]
		internal static extern int MsiGetSourcePath(MsiHandle hInstall, string szFolder, [Out] StringBuilder szPathBuf, ref int pcchPathBuf);

		[DllImport("msi.dll", CharSet = CharSet.Unicode)]
		internal static extern int MsiGetTargetPath(MsiHandle hInstall, string szFolder, [Out] StringBuilder szPathBuf, ref int pcchPathBuf);

		[DllImport("msi.dll", CharSet = CharSet.Unicode)]
		internal static extern int MsiProvideAssembly(string szAssemblyName, string szAppContext, int dwInstallMode, int dwAssemblyInfo, [Out] StringBuilder lpPathBuf, ref int pcchPathBuf);

		[DllImport("msi.dll", ExactSpelling = true)]
		internal static extern int MsiSetInstallLevel(MsiHandle hInstall, int iInstallLevel);

		[DllImport("msi.dll", ExactSpelling = true)]
		internal static extern MsiHandle MsiCreateRecord(int cParams);

		[DllImport("msi.dll", CharSet = CharSet.Unicode)]
		internal static extern int MsiGetFeatureState(MsiHandle hInstall, string szFeature, out InstallState piInstalled, out InstallState piAction);

		[DllImport("msi.dll", CharSet = CharSet.Unicode)]
		internal static extern int MsiGetComponentState(MsiHandle hInstall, string szComponent, out InstallState piInstalled, out InstallState piAction);

		[DllImport("msi.dll", CharSet = CharSet.Unicode)]
		internal static extern int MsiSetComponentState(MsiHandle hInstall, string szComponent, InstallState iState);

		[DllImport("msi.dll", CharSet = CharSet.Unicode)]
		internal static extern int MsiSetFeatureState(MsiHandle hInstall, string szFeature, InstallState iState);

		[DllImport("msi.dll", ExactSpelling = true)]
		internal static extern MsiHandle MsiGetLastErrorRecord();

		[DllImport("msi.dll", CharSet = CharSet.Unicode)]
		internal static extern int MsiDatabaseOpenView(MsiHandle hDatabase, string szQuery, out MsiHandle phView);

		[DllImport("msi.dll", CharSet = CharSet.Unicode)]
		internal static extern MsiHandle MsiGetActiveDatabase(MsiHandle session);

		[DllImport("msi.dll", CharSet = CharSet.Unicode)]
		internal static extern UInt32 MsiRecordDataSize(MsiHandle record, UInt32 field);

		[DllImport("msi.dll", CharSet = CharSet.Unicode)]
		internal static extern UInt32 MsiRecordReadStream(MsiHandle record, UInt32 field, byte[] buffer, ref int bufferLength);

		[DllImport("msi.dll", CharSet = CharSet.Unicode)]
		internal static extern UInt32 MsiCloseHandle(IntPtr handle);

		[DllImport("msi.dll", ExactSpelling = true)]
		internal static extern int MsiRecordGetInteger(MsiHandle hRecord, int iField);

		[DllImport("msi.dll", CharSet = CharSet.Unicode)]
		internal static extern int MsiRecordGetString(MsiHandle hRecord, int iField, [Out] StringBuilder szValueBuf, ref int pcchValueBuf);

		[DllImport("msi.dll", ExactSpelling = true)]
		internal static extern bool MsiRecordIsNull(MsiHandle hRecord, int iField);

		[DllImport("msi.dll", ExactSpelling = true)]
		internal static extern int MsiRecordReadStream(MsiHandle hRecord, int iField, [Out] byte[] szDataBuf, ref int pcbDataBuf);

		[DllImport("msi.dll", ExactSpelling = true)]
		internal static extern int MsiRecordDataSize(MsiHandle hRecord, int iField);

		[DllImport("msi.dll", ExactSpelling = true)]
		internal static extern int MsiRecordSetInteger(MsiHandle hRecord, int iField, int iValue);

		[DllImport("msi.dll", CharSet = CharSet.Unicode)]
		internal static extern int MsiRecordSetString(MsiHandle hRecord, int iField, string szValue);

		[DllImport("msi.dll", CharSet = CharSet.Unicode)]
		internal static extern int MsiRecordSetStream(MsiHandle hRecord, int iField, string szFilePath);

		[DllImport("msi.dll", ExactSpelling = true)]
		internal static extern int MsiRecordClearData(MsiHandle hRecord);

		[DllImport("msi.dll", ExactSpelling = true)]
		internal static extern int MsiRecordGetFieldCount(MsiHandle hRecord);

		[DllImport("msi.dll", ExactSpelling = true)]
		internal static extern int MsiViewExecute(MsiHandle hView, MsiHandle hRecord);

		[DllImport("msi.dll", ExactSpelling = true)]
		internal static extern int MsiViewFetch(MsiHandle hView, out MsiHandle phRecord);

		[DllImport("msi.dll", ExactSpelling = true)]
		internal static extern int MsiViewClose(MsiHandle hView);

        [DllImport("msi.dll", ExactSpelling = true)]
        internal static extern bool MsiGetMode(MsiHandle hrecord, InstallerRunMode mode);
        [DllImport("msi.dll", ExactSpelling = true)]
        internal static extern uint MsiSetMode(MsiHandle hrecord, InstallerRunMode mode, bool enabled);
	}
}
