using System;
using System.Collections;
using System.ComponentModel;
using System.Configuration.Install;
using System.IO;
using System.Threading;
using InfiniTec.Configuration.Install;

namespace ManagedCustomAction
{
    [RunInstaller(true)]
    class TestInstaller: Installer
    {
        public override void Commit(IDictionary savedState)
        {
            for (int i = 3 - 1; i >= 0; i--)
            {
                InstallerContext.Current.StartAction("ManagedCustomAction", string.Format("Commit: Waiting {0} seconds...", i), "Details: [1]");
                InstallerContext.Current.ReportDetails(Convert.ToString(3-i));
                Thread.Sleep(1000);
            }
            base.Commit(savedState);
        }

        public override void Install(IDictionary stateSaver)
        {
            for (int i = 3 - 1; i >= 0; i--)
            {
                InstallerContext.Current.StartAction("ManagedCustomAction", string.Format("Install: Waiting {0} seconds...", i), "");
                Thread.Sleep(1000);
            }
            base.Install(stateSaver);
        }

        public override void Uninstall(IDictionary savedState)
        {
            for (int i = 3 - 1; i >= 0; i--)
            {
                InstallerContext.Current.StartAction("ManagedCustomAction", string.Format("Uninstall: Waiting {0} seconds...", i), "");
                Thread.Sleep(1000);
            }
        }

        public override void Rollback(IDictionary savedState)
        {
            for (int i = 3 - 1; i >= 0; i--)
            {
                InstallerContext.Current.StartAction("ManagedCustomAction", string.Format("Rollback: Waiting {0} seconds...", i), "");
                Thread.Sleep(1000);
            }

            base.Rollback(savedState);
        }
    }
}
