using Microsoft.Tools.WindowsInstallerXml;

namespace ManagedInstallerWixExtension
{
    internal class CustomActionSettings
    {
        private string _Action;
        private string _Before;
        private string _After;
        private int? _Sequence;
        private string _Table;
        private string _Condition;
        private SourceLineNumberCollection _ChildSourceLineNumbers;


        public CustomActionSettings()
        {
        }

        public CustomActionSettings(string action, string before, string after, string table, string condition, SourceLineNumberCollection childSourceLineNumbers) : this(action, before, after, null, table, condition, childSourceLineNumbers)
        {
        }

        public CustomActionSettings(string action, string before, string after, int? sequence, string table, string condition, SourceLineNumberCollection childSourceLineNumbers)
        {
            _Action = action;
            _Before = before;
            _After = after;
            _Table = table;
            _Condition = condition;
            _Sequence = sequence;
            _ChildSourceLineNumbers = childSourceLineNumbers;
        }

        public string Action
        {
            get { return _Action; }
            set { _Action = value; }
        }

        public string Before
        {
            get { return _Before; }
            set { _Before = value; }
        }

        public string After
        {
            get { return _After; }
            set { _After = value; }
        }

        public int? Sequence
        {
            get { return _Sequence; }
            set { _Sequence = value; }
        }

        public string Table
        {
            get { return _Table; }
            set { _Table = value; }
        }

        public string Condition
        {
            get { return _Condition; }
            set { _Condition = value; }
        }

        public SourceLineNumberCollection ChildSourceLineNumbers
        {
            get { return _ChildSourceLineNumbers; }
            set { _ChildSourceLineNumbers = value; }
        }
    }
}